pipeline {
    agent {
        label 'vm5'
    } 
    environment {
        APP_NAME = "test app"
        IMAGE_NAME = "registry.gitlab.com/sommai.k/first"
    }
    stages {
        stage('Build Image') {
            steps {
                sh "echo ${env.APP_NAME}"
                sh "docker build -t ${env.IMAGE_NAME}:${env.BUILD_NUMBER} ."
            }
        }
        stage('Deliver Image') {
            steps {
                withCredentials(
                [usernamePassword(
                    credentialsId: 'gitlab-id',
                    passwordVariable: 'gitlabPassword',
                    usernameVariable: 'gitlabUser'
                )]
            ){
                sh "docker login -u ${env.gitlabUser} -p ${env.gitlabPassword} registry.gitlab.com"
                sh "docker push ${env.IMAGE_NAME}:${env.BUILD_NUMBER}"
            }
            }
        }
        stage('Deploy Image') {
          agent {
              label 'vm1'
          }
          steps {
              withCredentials(
                [usernamePassword(
                    credentialsId: 'gitlab-id',
                    passwordVariable: 'gitlabPassword',
                    usernameVariable: 'gitlabUser'
                )]
            ){
              script {
                  try {
                    sh "docker login -u ${env.gitlabUser} -p ${env.gitlabPassword} registry.gitlab.com"  
                    sh "docker service update first --with-registry-auth --image ${env.IMAGE_NAME}:${env.BUILD_NUMBER}"
                    sh "echo update service"
                  } catch (e){
                    sh "docker service create --with-registry-auth --name first -p 8080:80 ${env.IMAGE_NAME}:${env.BUILD_NUMBER}"
                    sh "echo create service"
                  }
              }
            }
          }
       }
    }
}